"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = exports.name = void 0;
const amplify_cli_core_1 = require("amplify-cli-core");
const amplify_prompts_1 = require("amplify-prompts");
const graphql_transformer_migrator_1 = require("@aws-amplify/graphql-transformer-migrator");
const path = __importStar(require("path"));
const category_constants_1 = require("../../category-constants");
const subcommand = 'migrate';
exports.name = subcommand;
const run = async (context) => {
    var _a, _b, _c;
    const apiNames = Object.entries(((_a = amplify_cli_core_1.stateManager.getMeta()) === null || _a === void 0 ? void 0 : _a.api) || {})
        .filter(([_, apiResource]) => apiResource.service === 'AppSync')
        .map(([name]) => name);
    if (apiNames.length === 0) {
        amplify_prompts_1.printer.info('No GraphQL API configured in the project. Only GraphQL APIs can be migrated. To add a GraphQL API run `amplify add api`.');
        return;
    }
    if (apiNames.length > 1) {
        amplify_prompts_1.printer.error('You have multiple GraphQL APIs in the project. Only one GraphQL API is allowed per project. Run `amplify remove api` to remove an API.');
        return;
    }
    const apiName = apiNames[0];
    const apiResourceDir = path.join(amplify_cli_core_1.pathManager.getBackendDirPath(), category_constants_1.category, apiName);
    if ((_c = (_b = context.parameters) === null || _b === void 0 ? void 0 : _b.options) === null || _c === void 0 ? void 0 : _c.revert) {
        await graphql_transformer_migrator_1.revertV2Migration(apiResourceDir, amplify_cli_core_1.stateManager.getCurrentEnvName());
        return;
    }
    await graphql_transformer_migrator_1.attemptV2TransformerMigration(apiResourceDir, apiName, amplify_cli_core_1.stateManager.getCurrentEnvName());
};
exports.run = run;
//# sourceMappingURL=migrate.js.map