const subcommand = 'update';
const category = 'api';
module.exports = {
    name: subcommand,
    alias: ['configure'],
    run: async (context) => {
        const { amplify } = context;
        const servicesMetadata = require('../../provider-utils/supported-services').supportedServices;
        return amplify
            .serviceSelectionPrompt(context, category, servicesMetadata)
            .then(result => {
            const providerController = require(`../../provider-utils/${result.providerName}/index`);
            if (!providerController) {
                context.print.error('Provider not configured for this category');
                return;
            }
            return providerController.updateResource(context, category, result.service);
        })
            .then(() => context.print.success('Successfully updated resource'))
            .catch(err => {
            context.print.error(err.message);
            console.log(err.stack);
            context.usageData.emitError(err);
            process.exitCode = 1;
        });
    },
};
//# sourceMappingURL=update.js.map