import * as ecr from '@aws-cdk/aws-ecr';
import * as ecs from '@aws-cdk/aws-ecs';
import * as s3 from '@aws-cdk/aws-s3';
import * as cdk from '@aws-cdk/core';
import { DEPLOYMENT_MECHANISM } from './base-api-stack';
export declare type GitHubSourceActionInfo = {
    path: string;
    tokenSecretArn: string;
};
export declare class PipelineWithAwaiter extends cdk.Construct {
    pipelineName: string;
    constructor(scope: cdk.Construct, id: string, { skipWait, bucket, s3SourceActionKey, service, deploymentMechanism, gitHubSourceActionInfo, containersInfo, desiredCount, envName, }: {
        skipWait?: boolean;
        bucket: s3.IBucket;
        s3SourceActionKey?: string;
        deploymentMechanism: DEPLOYMENT_MECHANISM;
        gitHubSourceActionInfo?: GitHubSourceActionInfo;
        service: ecs.CfnService;
        containersInfo: {
            container: ecs.ContainerDefinition;
            repository: ecr.IRepository;
        }[];
        desiredCount: number;
        envName: string;
    });
    getPipelineName(): string;
}
export declare type ContainerStackProps = {
    deploymentBucket: string;
    containerPort: number;
    awaiterZipPath: string;
    gitHubPath?: string;
    gitHubTokenSecretsManagerArn: string;
};
//# sourceMappingURL=pipeline-with-awaiter.d.ts.map