"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setExistingSecretArns = void 0;
const lodash_1 = __importDefault(require("lodash"));
const setExistingSecretArns = (secretsMap, cfnObj) => {
    var _a;
    if (lodash_1.default.isEmpty(cfnObj)) {
        return;
    }
    const taskDef = Object.values(cfnObj === null || cfnObj === void 0 ? void 0 : cfnObj.Resources)
        .find((value) => (value === null || value === void 0 ? void 0 : value.Type) === 'AWS::ECS::TaskDefinition');
    const containerDefs = (_a = taskDef === null || taskDef === void 0 ? void 0 : taskDef.Properties) === null || _a === void 0 ? void 0 : _a.ContainerDefinitions;
    if (!Array.isArray(containerDefs)) {
        return;
    }
    containerDefs
        .map(def => def === null || def === void 0 ? void 0 : def.Secrets)
        .filter(secrets => !lodash_1.default.isEmpty(secrets))
        .flat(1)
        .filter(secretDef => !!(secretDef === null || secretDef === void 0 ? void 0 : secretDef.Name))
        .filter(secretDef => !!secretDef.ValueFrom)
        .forEach(secretDef => secretsMap.set(secretDef.Name, secretDef.ValueFrom));
};
exports.setExistingSecretArns = setExistingSecretArns;
//# sourceMappingURL=set-existing-secret-arns.js.map