"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.editSchemaFlow = void 0;
const inquirer_1 = __importDefault(require("inquirer"));
const path_1 = __importDefault(require("path"));
const category_constants_1 = require("../../../category-constants");
const aws_constants_1 = require("../aws-constants");
const editSchemaFlow = async (context, apiName) => {
    const prompt = {
        type: 'confirm',
        name: 'editNow',
        message: 'Do you want to edit the schema now?',
        default: true,
    };
    if (!(await inquirer_1.default.prompt(prompt)).editNow)
        return;
    const schemaPath = path_1.default.join(context.amplify.pathManager.getBackendDirPath(), category_constants_1.category, apiName, aws_constants_1.gqlSchemaFilename);
    await context.amplify.openEditor(context, schemaPath, false);
};
exports.editSchemaFlow = editSchemaFlow;
//# sourceMappingURL=edit-schema-flow.js.map