"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.printApiKeyWarnings = void 0;
const printApiKeyWarnings = (context, oldConfigHadApiKey, newConfigHasApiKey) => {
    if (oldConfigHadApiKey && !newConfigHasApiKey) {
        context.print.warning('The API_KEY auth type has been removed from the API.');
        context.print.warning('If other resources depend on this API, run "amplify update <category>" and reselect this API to remove the dependency on the API key.');
        context.print.warning('⚠️  This must be done before running "amplify push" to prevent a push failure');
    }
    if (!oldConfigHadApiKey && newConfigHasApiKey) {
        context.print.warning('The API_KEY auth type has been added to the API.');
        context.print.warning('⚠️  If other resources depend on this API and need access to the API key, run "amplify update <category>" and reselect this API as a dependency to add the API key dependency.');
    }
};
exports.printApiKeyWarnings = printApiKeyWarnings;
//# sourceMappingURL=print-api-key-warnings.js.map